<?php
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_product_typeTangible extends JPlugin
{
	function plgJoomsuite_product_typeTangible( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField( &$obj, &$params, $type)
	{
		if($type != 'tangible') return;
		$def = JRequest::getVar('fields', null, 'default', 'array');
		//if($def[$obj->id]) $obj->field_value = $def[$obj->id];
		$out = '';
		if($params->get('show_weight'))//$obj->show_weight
		{
			$weight = explode("\n", $params->get('weight_units'));//$obj->weight_units);//
			$out .= JText::_("Weight").'<br><input type="text" value="'.(isset($obj->weight) ? $obj->weight : '').'" name="pparams['.$obj->id.'][weight]" size="10" id="pparams'.$obj->id.'weight" onKeyup="formatFloat(\'pparams'.$obj->id.'weight\')">';
			foreach ($weight as $val){
				$unit = explode(":", $val);
				$opt[] = JHTML::_('select.option', $unit[0], $unit[0]);
			}

			$out .= JHTML::_("select.genericlist", $opt, 'pparams['.$obj->id.'][weight_unit]', "class='inputbox' style='width: 50px'", 'value', 'text', (isset($obj->weight_unit) ? $obj->weight_unit : ''));
		}
		$opt = array();
		if($params->get('show_lbh'))//isset($obj->show_lbh) && $obj->show_lbh
		{
			$lbh = explode("\n", $params->get('lbh_units'));//$obj->lbh_units);//
			foreach ($lbh as $val){
				$unit = explode(":", $val);
				$opt[] = JHTML::_('select.option', $unit[0], $unit[0]);
			}
			$list = JHTML::_("select.genericlist", $opt, 'pparams['.$obj->id.'][lbh_unit]', "class='inputbox' style='width: 50px'", 'value', 'text', (isset($obj->lbh_unit) ? $obj->lbh_unit : ''));
			$out .= '<br><br>
			<table width="30%" cellspacing="0" cellpadding="0" border="0">
				<tr>
					<td nowrap>'.JText::_("Width").'<br>
						<input type="text" value="'.(isset($obj->lbh_l) ? $obj->lbh_l : '').'" name="pparams['.$obj->id.'][lbh_l]" size="10" id="pparams'.$obj->id.'lbh_l" onKeyup="formatFloat(\'pparams'.$obj->id.'lbh_l\')">
					</td>
					<td nowrap>'.JText::_("Height").'<br> 
						<input type="text" value="'.(isset($obj->lbh_b) ? $obj->lbh_b : '').'" name="pparams['.$obj->id.'][lbh_b]" size="10" id="pparams'.$obj->id.'lbh_b" onKeyup="formatFloat(\'pparams'.$obj->id.'lbh_b\')">
					<td nowrap>'.JText::_("Length").'<br> 
						<input type="text" value="'.(isset($obj->lbh_h) ? $obj->lbh_h : '').'" name="pparams['.$obj->id.'][lbh_h]" size="10" id="pparams'.$obj->id.'lbh_h" onKeyup="formatFloat(\'pparams'.$obj->id.'lbh_h\')">
					</td>
					<td valign="bottom">'.$list.'</td>
				</tr>
			</table>';

		}
		$opt = array();
		if($params->get('show_volume'))//$obj->show_volume
		{
			$volume = explode("\n", $params->get('volume_units'));//$obj->volume_units);//
			$out .= '<br>'. JText::_("Volume").'<br><input type="text" value="'.(isset($obj->volume) ? $obj->volume : '').'" name="pparams['.$obj->id.'][volume]" size="10" id="pparams'.$obj->id.'volume" onKeyup="formatFloat(\'pparams'.$obj->id.'volume\')">';
			foreach ($volume as $val){
				$unit = explode(":", $val);
				$opt[] = JHTML::_('select.option', $unit[0], $unit[0]."<sup>3</sup>");
			}

			$out .= JHTML::_("select.genericlist", $opt, 'pparams['.$obj->id.'][volume_unit]', "class='inputbox' style='width: 50px'", 'value', 'text', (isset($obj->volume_unit) ? $obj->volume_unit : ''));
		}

		$out .= '<br><br>Storage on hand<br>
		<input type="text" name="pparams['.$obj->id.'][storage]" value="'.(isset($obj->storage) ? $obj->storage : '0').'" id="storage-'.$obj->id.'"
		onKeyUp="formatInt(\'storage-'.$obj->id.'\')">';
		?>
<script type="text/javascript">
			function formatInt(id)
			  {
			      var cur = document.getElementById(id).value;
			      reg = /[^\d]+/;
			      cur = cur.replace(reg, "");
			      document.getElementById(id).value = cur;
			  }
			</script>
		<?php
		echo $out;

	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'tangible') return;
		if(!$value) return;

		$db = &JFactory::getDBO();
		$value = $db->getEscaped(trim($value));
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		$type = $field->type;
		if($type != 'tangible') return;
		if(!$field) return;
		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		
		$out = '';
		if($params->get('show_type'))
		{
			$val = new JParameter($field->value);

			$tmp = array();
			$out = '<table width="100%" cellspacing="0" cellpadding="0" border="0">';
			if($params->get('show_weight')) {
				$weight_unit = $val->get('weight_unit');
				$weight = $val->get('weight');
				if(!$weight )	{
					$out = '';
					return;
				}/*
				if($weight_unit != 'kg') {
					$weight_units = explode("\n", $params->get('weight_units'));
					foreach($weight_units as $unit)
					{
						if(strstr($unit, "$weight_unit")) {
							$index = explode(":", $unit);
							$weight = round($weight * $index[1], 3);
						}
					}
				}*/
				$out .= '<tr><td width="20%"><b>'.JText::_("Weight")."</b>:</td><td>". $weight.' '.$weight_unit.'</td></tr>';

			}
			if($params->get('show_lbh')) {//echo $params->get('lbh_units');
				$lbh_unit = $val->get('lbh_unit');
				$lbh_l = $val->get('lbh_l');
				$lbh_b = $val->get('lbh_b');
				$lbh_h = $val->get('lbh_h');
				if($lbh_l || $lbh_b || $lbh_h)
				{
					/*if($lbh_unit != 'cm') {
						$lbh_units = explode("\n", $params->get('lbh_units'));
						foreach($lbh_units as $unit)
						{
							if(strstr($unit, "$lbh_unit")) {
								$index = explode(":", $unit);
								$lbh_l = round($lbh_l * $index[1], 3);
								$lbh_b = round($lbh_b * $index[1], 3);
								$lbh_h = round($lbh_h * $index[1], 3);
							}
						}
					}*/
					$out .= '<tr><td width="20%"><b>'.JText::_("LBH")."</b>:</td><td>". $lbh_l." x ".$lbh_b." x ".$lbh_h." ".$lbh_unit.'</td></tr>';
				}
			}
			if($params->get('show_volume')) {//echo $params->get('volume_units');
				$volume_unit = $val->get('volume_unit');
				if($volume = $val->get('volume'))
				{
					/*if($volume_unit != 'm') {
						$volume_units = explode("\n", $params->get('volume_units'));
						foreach($volume_units as $unit)
						{
							if(strstr($unit, "$volume_unit")) {
								$index = explode(":", $unit);
								$volume = round($volume * pow($index[1], 3), 3);
							}
						}
					}*/
					$out .= '<tr><td width="20%"><b>'.JText::_("Volume")."</b>:</td><td>". $volume." ".$volume_unit."<sup>3</sup></td></tr>";
				}
			}

			if($params->get('show_storage'))
			{
				$amount = $val->get('storage');
				$out .= '<tr class="small"><td width="20%"><b>'.JText::_("Storage on hand")."</b>:</td><td>". ($amount ? $amount.' '. JText::_('items') : JText::_('There are no items on storage'))."</td></tr>";
			}
			$out .= '</table>';
		}


	}

	function onAfterSuccessOrder($type, $order_id, $product_id, $field_id, $value, $user_id, $amount)
	{
		if($type != 'tangible') return;

		$db = & Jfactory::getDBO();
		$obj = new JParameter($value);
		$storage = $obj->get('storage');
		if($storage && $storage > 0)
		{
			if($storage >= $amount)
			$obj->set('storage', $storage - $amount);
			else
			$obj->set('storage', 0);
			$sql = "Update #__js_res_field_extra SET value = '".$obj->toString()."' WHERE record_id = '$product_id' AND ref_id = 'tangible'
			AND field_id = '$field_id'";
			$db->setQuery($sql);
			$db->query();
		}
	}

	function onTypeFormRender()
	{

	}

	function onBeforeCartStore()
	{

	}
}
?>